<?php

namespace FiloBlu\Flow\Model\Filters;



/**
 * Class BarcodeToSkuConverter
 * @package FiloBlu\Flow\Model\Filters
 */
class BarcodeToSkuConverter extends AbstractFilter
{

    protected $_resource;
    protected $connection;

    public function __construct(
        \Magento\Framework\App\ResourceConnection $resource
    ) {
        $this->_resource = $resource;
    }

    /**
     * @param $value
     * @param $args
     * @return string
     */
    public function filter($value, $args)
    {
        $barcode = trim($value);

        $type_simple = \Magento\Catalog\Model\Product\Type::TYPE_SIMPLE;
        $barcode_attribute_code = 'barcode';
        $catalog_product_type_id = 4;

        $sql = "SELECT CPE.sku FROM catalog_product_entity CPE
                LEFT JOIN catalog_product_entity_varchar CPEV ON CPE.row_id = CPEV.row_id AND CPEV.attribute_id IN (
                    SELECT attribute_id 
                    FROM eav_attribute 
                    WHERE attribute_code = '{$barcode_attribute_code}' AND entity_type_id = {$catalog_product_type_id}
                    )
                WHERE CPE.type_id = '{$type_simple}'
                AND CPEV.value IS NOT NULL
                AND CPEV.value = '{$barcode}'";
        $sku = $this->getConnection()->fetchOne($sql);

        if (!$sku){
            $sku = "barcode_{$barcode}_missing";
        }
        return $sku;
    }

    protected function getConnection()
    {
        if (!$this->connection) {
            $this->connection = $this->_resource->getConnection('core_write');
        }
        return $this->connection;
    }
}